# Copyright (c) 2000-2010, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_without repolib

%define repodir_root repository.jboss.com
%define repodir_release jboss/jbossws-framework/%{version_full}
%define repodir %{_javadir}/repository.jboss.com/jboss/jbossws-framework/%{version_full}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src
 
%define version_maj 3
%define version_min 1
%define version_rev 2
%define version_tag SP10
%define version_full %{version_maj}.%{version_min}.%{version_rev}.%{version_tag}

Name:           jbossws-framework
Version:        %{version_maj}.%{version_min}.%{version_rev}
Release:        6.%{version_tag}.2%{?dist}
Epoch:          0
License:        LGPLv2+
Summary:        JBoss Web Services (framework)
Group:          Development/Java
URL:            http://labs.jboss.com/jbossws/
# svn export https://svn.jboss.org/repos/jbossws/framework/tags/jbossws-framework-3.1.2.SP10/
# Exported revision 14900.
# tar czf jbossws-framework-3.1.2.SP10.tar.gz jbossws-framework-3.1.2.SP10
Source0:        jbossws-framework-%{version_full}.tar.gz
Source1:        jbossws-framework-jpp-depmap.xml
Source2:        jbossws-framework-component-info.xml
Patch0:         jbossws-framework-pom.xml.patch
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       jpackage-utils
Requires:       wsdl4j >= 0:1.6.1
BuildRequires:  jboss-jms-1.1-api
BuildRequires:  maven2
BuildRequires:  maven2-plugin-antrun
BuildRequires:  maven2-plugin-assembly
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-source
BuildRequires:  maven2-plugin-release
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-enforcer
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  maven-surefire-provider-junit
BuildRequires:	codehaus-stax11-api
BuildRequires:  jboss-parent
BuildRequires:	jboss-javaee
BuildRequires:  jboss-javaee-poms
BuildRequires:  jboss-ejb-3.0-api
BuildRequires:   jboss-jaxrpc-api_1.1_spec
BuildRequires:  jbossws-parent
BuildRequires:  jbossws-spi >= 1.1.2-1.SP1.1
BuildRequires:  jbossws-common >= 1.1.0-0.SP2.1
BuildRequires:  dom4j >= 1.6.1
BuildRequires:  jboss-common-core
BuildRequires: jbossweb-servlet-2.5-api
BuildRequires:  jbossxb2
BuildRequires:  glassfish-jaxws
BuildRequires:  junit >= 3.8.1
BuildRequires:	sun-ws-metadata-2.0-api
BuildRequires:  tjws
BuildRequires:  wsdl4j
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
JBossWS Framework.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%setup -q -n jbossws-framework-%{version_full}

%define reposave output/reposave
reposave=%{reposave}
sed -i "s|@REPOSAVE@|$reposave|" %{PATCH0}
%patch0 -p0

find . -name "*.jar" -exec rm -f {} \;

%build
export MAVEN_REPO_LOCAL=$(pwd)/.m2/repository
mkdir -p $MAVEN_REPO_LOCAL
mkdir -p ./output/reposave
%{_bindir}/mvn-jpp \
        -e \
        -Djboss.repository=$(pwd)/repository \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven2.jpp.depmap.file=%{SOURCE1} \
        -Djboss.local.repository=./output/reposave \
        install

%install
rm -rf $RPM_BUILD_ROOT

install -d -m 0755 $RPM_BUILD_ROOT%{_javadir}
install -p -m 0644 target/jbossws-framework-%{version_full}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version_full}.jar
install -p -m 0644 target/jbossws-framework-%{version_full}-sources.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version_full}-sources.jar
install -p -m 0644 target/jbossws-framework-%{version_full}-testsuite.zip $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version_full}-testsuite.zip

pushd $RPM_BUILD_ROOT%{_javadir}
ln -s %{name}-%{version_full}.jar %{name}.jar
ln -s %{name}-%{version_full}-sources.jar %{name}-sources.jar
ln -s %{name}-%{version_full}-testsuite.zip %{name}-testsuite.zip
popd

%{__mkdir_p} %{buildroot}%{_datadir}/maven2/poms
%{__cp} -p pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}.pom
%add_to_maven_depmap org.jboss.ws jbossws-framework %{version_full} JPP %{name}

%if %with repolib
install -d -m 755 $RPM_BUILD_ROOT%{repodir}
install -d -m 755 $RPM_BUILD_ROOT%{repodirlib}
install -d -m 755 $RPM_BUILD_ROOT%{repodirsrc}
cp -p %{SOURCE2} $RPM_BUILD_ROOT%{repodir}/component-info.xml
sed -i 's/@VERSION@/%{version_full}-brew/g' $RPM_BUILD_ROOT%{repodir}/component-info.xml
tag=`echo %{name}-%{version}-%{release} | sed 's|\.|_|g'`
sed -i "s/@TAG@/$tag/g" $RPM_BUILD_ROOT%{repodir}/component-info.xml
install -p -m 644 %{SOURCE0} $RPM_BUILD_ROOT%{repodirsrc}
install -p -m 644 %{SOURCE1} $RPM_BUILD_ROOT%{repodirsrc}
install -p -m 644 %{PATCH0} $RPM_BUILD_ROOT%{repodirsrc}
#cp -pr %{reposave}/%{repodir_release}/* $RPM_BUILD_ROOT%{repodir}
install -p -m 0644 target/%{name}-%{version_full}.jar $RPM_BUILD_ROOT%{repodirlib}/jbossws-framework.jar
cp -p pom.xml $RPM_BUILD_ROOT%{repodirlib}/jbossws-framework.pom
install -p -m 0644 target/%{name}-%{version_full}-sources.jar $RPM_BUILD_ROOT%{repodirlib}/jbossws-framework-sources.jar
cp -p target/%{name}-%{version_full}-testsuite.zip $RPM_BUILD_ROOT%{repodir}/lib/jbossws-framework-testsuite.zip
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%{_javadir}/%{name}-%{version_full}-testsuite.zip
%{_javadir}/%{name}-testsuite.zip
%{_javadir}/%{name}-%{version_full}-sources.jar
%{_javadir}/%{name}-sources.jar
%{_javadir}/%{name}-%{version_full}.jar
%{_javadir}/%{name}.jar
%{_datadir}/maven2/poms/JPP-%{name}.pom
%{_mavendepmapfragdir}/%{name}

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}
%{_javadir}/repository.jboss.com
%endif

%changelog
* Thu Sep 8 2011 Danesh Mondegarian <dmondega@redhat.com> 0:3.1.2-6.SP10.2
- Rebuild

* Wed Aug 24 2011 Danesh Mondegarian <dmondega@redhat.com> 0:3.1.2-6.SP10.1
- Upgraded to SP10

* Wed Mar 23 2011 Yiqiao Wang <yiwang@redhat.com> 0:3.1.2-5.SP9.1
- Upgrade to 3.1.2.SP9
- Use jaxrpc provided by jboss-jaxrpc-api_1.1_spec 
- Add BR jboss-jaxrpc-api_1.1_spec, modify depmap entry
- Add the line to find and remove any binaries
- Chanage BR jbossxb >= 1.0.0 to jbossxb2
- Fix depmap entries

* Tue Jul 20 2010 Yiqiao Wang <yiwang@redhat.com> 0:3.1.2-4.SP7.1
- Upgrade to 3.1.2.SP8
- Change BR: jboss-common to jboss-common-core, edit its depmap entry. 

* Mon Jun 28 2010 Permaine Cheung <pcheung@redhat.com> 0:3.1.2-3.SP7.4
- Remove tjws from the pom as it is not used for compile

* Wed Jun 23 2010 Permaine Cheung <pcheung@redhat.com> 0:3.1.2-3.SP7.3
- Remove Requires on tjws as it is transitive dependency that we 
  don't want to ship

* Tue Jun 15 2010 David Walluck <dwalluck@redhat.com> 0:3.1.2-3.SP7.2
- fix Requires on jpackage-utils (especially for maven2 scriptlets)
- add Requires on tjws and wsdl4j as in the pom
- fix repolib

* Thu May 27 2010 Yiqiao Wang <yiwang@redhat.com> - 0:3.1.2-3.SP7.1
- Upgrade to 3.1.2.SP7
- Add BR:  maven2-plugin-enforcer
- Add BR:  jboss-jms-1.1-api, added its depmap entry. 

* Fri May 07 2010 Martha Benitez <mbenitez@redhat.com> - 0:3.1.2-2.SP4_CP01.2.1
- rebuilt

* Wed Apr 7 2010 Luiz Barreiros <gbarreir@redhat.com> 0:3.1.2-3.SP4_CP01.1
- Rebuild

* Fri Jan 22 2010 Martha Benitez <mbenitez@redhat.com> 0:3.1.2-2.SP4_CP01.1
- Upgrade to 3.1.2.SP4_CP01
- Add BR codehaus-stax11-api, sun-ws-metadata-2.0-api, jboss-javaee and their depmap entries
- Change to %{version_full} for depmap entry
- Add pom.xml to repolib

* Tue Jul 21 2009 Permaine Cheung <pcheung@redhat.com> 0:3.1.2-1.SP4.5
- Fix component-info.xml

* Tue Jul 21 2009 Permaine Cheung <pcheung@redhat.com> 0:3.1.2-1.SP4.4
- Fix component-info.xml

* Mon Jul 20 2009 Permaine Cheung <pcheung@redhat.com> 0:3.1.2-1.SP4.3
- BR tjws and add depmap

* Mon Jul 20 2009 Permaine Cheung <pcheung@redhat.com> 0:3.1.2-1.SP4.2
- Rebuild with latest jbossws

* Mon Jul 20 2009 Permaine Cheung <pcheung@redhat.com> 0:3.1.2-1.SP4.1
- Upgrade to 3.1.2.SP4

* Tue Jul 14 2009 Permaine Cheung <pcheung@redhat.com> 0:3.1.2-1.SP3.3
- Update src tar ball

* Mon Jul 13 2009 Permaine Cheung <pcheung@redhat.com> 0:3.1.2-1.SP3.2
- Add testsuite.zip

* Thu Jul 09 2009 Permaine Cheung <pcheung@redhat.com> 0:3.1.2.SP3
- Upgrade to 3.1.2.SP3
- Build with maven
- Use jbossws for building until we have jbossws-native built

